<?php
if (!session_id())
  session_start();
 /*
    Plugin Name: Import Spreadsheets from Microsoft Excel
    Plugin URI: http://www.spreadsheetconverter.com
    Description: Import Spreadsheets from Microsoft Excel
    Version: 9.0.1
    Author: SpreadsheetConverter
    Author URI: http://www.spreadsheetconverter.com    
    Text Domain: SpreadsheetConverter
    License: GPLv2 or later
    Publish tool: Subversion
    Permission: needs user's permission to embed Powered-by link on embedded page
    Documentation: readme.txt
   */

   /*Define Shortcode Manager Plugins */
  define( 'TF_CPT_PLUGIN_DIR_MANAGER', dirname(__FILE__) . '/' );
  define( 'TF_CPT_PLUGIN_URL_MANAGER', plugin_dir_url(__FILE__)) ;
// echo extension_loaded('zip') ? 'OK' : 'MISSING', '<br>';die;



function ssc_activate( $network_wide ) {
       if(!extension_loaded('zip')){
           
            echo '<h3>'.__('Please install or enable PHP extension ZIPArchive before activating plugin.').'</h3>';
            errorLog('Please install or enable PHP extension ZIPArchive before activating plugin.');
            //Adding @ before will prevent XDebug output
            @trigger_error(__('Please install or enable PHP extension ZIPArchive before activating plugin.', 'ap'), E_USER_ERROR);

    }
}

register_activation_hook(__FILE__, 'ssc_activate');


   
   /* add_filter('wp_default_editor', create_function('', 'return "html";'));*/

    //require_once('tulips_shortcode_generator_box.php');

    function shortcode_manager_style() {
      wp_enqueue_style( 'custom', TF_CPT_PLUGIN_URL_MANAGER.'css/custom.css' );
     
    }
    add_action( 'wp_enqueue_scripts', 'shortcode_manager_style' );

    //Register Scripts For ShortCode Manager
    function shortcode_manager_scripts( $hook ) {
     
        wp_register_script( 'shortcode-manager-scripts', TF_CPT_PLUGIN_URL_MANAGER . 'js/shortcode-manager-scripts.js', array( 'jquery', 'jquery-ui-core', 'jquery-ui-datepicker', 'media-upload','thickbox' ) );
        wp_enqueue_script( 'shortcode-manager-scripts' );
        wp_enqueue_script('jquery-ui-resizable');      
        wp_register_style( 'shortcode-manager-styles', TF_CPT_PLUGIN_URL_MANAGER. 'css/style.css', array( 'thickbox' ) );
        wp_enqueue_style( 'shortcode-manager-styles' );


    }
    add_action( 'admin_enqueue_scripts', 'shortcode_manager_scripts', 10 );

    function ssc_add_editor_styles() {
      // add_editor_style( TF_CPT_PLUGIN_URL_MANAGER . 'jquery-ui.css' );
        add_editor_style( TF_CPT_PLUGIN_URL_MANAGER . 'css/admin.css' );
    }
    add_action( 'after_setup_theme', 'ssc_add_editor_styles' );

    add_action( 'after_wp_tiny_mce', 'ssc_after_wp_tiny_mce' );
    function ssc_after_wp_tiny_mce() {
        if (!jQuery) { 
        printf( '<script type="text/javascript" src="%s"></script>',  plugins_url('/js/jquery-1.11.3.min', __FILE__) );
         }
       
    }
     
    //add_action('admin_print_styles', 'auctions_admin_print_styles_332');

    // function auctions_admin_print_styles_332(){
    //    if ((isset($_GET['post_type']) && $_GET['post_type'] == 'file') || (isset($post_type) && $post_type == 'file')){

    //      //include your css file using wp_enqueue_style() somthing like
    //       wp_enqueue_style( 'ssc-look-styles', TF_CPT_PLUGIN_URL_MANAGER. 'custom.css', array(), '1.0' );

    //       // or a more hackish way would be to echo out the css style tag
    //   }
    // }

    add_action( 'init', 'wptuts_buttons' );
    function wptuts_buttons() {
        add_filter( "mce_external_plugins", "wptuts_add_buttons" );
        add_filter( 'mce_buttons', 'wptuts_register_buttons' );
    }
    function wptuts_add_buttons( $plugin_array ) {
        $plugin_array['wptuts'] = TF_CPT_PLUGIN_URL_MANAGER . 'js/admin.js';
        return $plugin_array;
    }
    function wptuts_register_buttons( $buttons ) {
        array_push( $buttons, 'deleteCalculator'); // dropcap', 'recentposts
        return $buttons;
    }

    add_action('admin_print_styles', 'add_my_tinymce_button_css');
    function add_my_tinymce_button_css() {

        $screen = get_current_screen();      
        if ( $screen->id == 'page' || $screen->id == 'post' ) {
            wp_register_style('my_tinymce_button_css', plugin_dir_url( __FILE__ ) . ('/css/admin.css'), array());        
            wp_enqueue_style('my_tinymce_button_css');
         
            wp_enqueue_style('dashicons');
        }
    }
    /*
     * Add button to the media button context in edit/add new post screen
     *
     */

    add_action('media_buttons_context',  'ttc_files_button');

    add_action( 'admin_footer',  'add_inline_files_popup_content' );

    function ttc_files_button($context) {
      //$context .= "<a id='files_media_link' href='#TB_inline?width=650&height=600&inlineId=files_popup_container&guid=".uniqid()."' class='button thickbox files_media_link' title='Insert objects & buttons'><span class='files_media_icon'></span>Add objects & buttons</a>";
      $context .= "<a id='files_media_link' href='#TB_inline?width=650&height=600&inlineId=tt_shortcode_popup_container&guid=".uniqid()."' class='button thickbox' title='Embed SpreadsheetConverter Calculator'><span class='files_media_icon'></span>Embed SSC Calculator</a>";
      $context .= "
        <style>
        .files_media_icon{
        background:url(" .TF_CPT_PLUGIN_URL_MANAGER. "/icon/add_shortcode.png) no-repeat top left;
        display: inline-block;
        height: 16px;
        margin: 0 2px 0 0;
        vertical-align: text-top;
        width: 16px;
        }
        .wp-core-ui a.files_media_link{
        padding-left: 0.4em;
        }
        </style>";
      return $context;
    }

    function sort_by_post_type () {
                                global $wpdb;
                                return " $wpdb->posts.post_type ASC ";
    }
    function add_inline_files_popup_content() {
    ?>
        <div id="tt_shortcode_popup_container" style="display:none;">
            <h2><?php bloginfo('name');_e('Shortcode Manager', 'projectx');?></h2>

            <div class="wrap" id="tabs_container">
                <ul class="tabs">
                    <li class="active">
                        <a href="#" id="tab1" rel="#tab_1_contents" class="tab">Calculator Block</a>
                    </li>
                </ul>

            <div class="tab_contents_container">
            
            <div id="tab_1_contents" class="tab_contents tab_contents_active">
          <!--ShortCode For Button Interface-->
            <form>        
                <div style="padding-left:143px; margin-bottom: -10px;" class=""><i>Select the previously uploaded calculator or form you want to embed at the current cursor position.</i></div>
                    <ul id="btn_shortcode">

                        <li>
                            <label style="width:140px;display: inline-block;">Calculator Link<em style="color:red">*</em></label>
                            <?php
                                //global $post;
                    remove_all_filters('posts_orderby');
                    $args = array(
                                        'post_status' =>'publish',
                                        'post_type' => array('file'),
                                        'showposts' =>-1,
                                        'orderby' =>'post_date',
                                        'order' =>'DESC'
                                    );
                    // add_filter('posts_orderby', 'sort_by_post_type' );

                                // The Query
                                $my_query = new WP_Query( $args );
                    // remove_filter('posts_orderby','sort_by_post_type');
                    ?>
                                <select name="btn_link" id="btn_link" style="width:67%">
                                    <option value="0" >Select Links</option>
                                    <?php while ( $my_query->have_posts() ) : $m_post = $my_query->next_post();?>
                                            <option value="<?php echo ($m_post->ID) ?>">
                                                <?php
                                                        $post_type = $m_post->post_type;
                                                        $post_type_data = get_post_type_object( $post_type );
                                                        // echo strtoupper($post_type_data->labels->name);
                                                        // echo ' ---';

                                                     ?>
                            <?php echo $m_post->post_title;?>
                                            </option>

                                    <?php endwhile;
                                echo '</select>';
                                // Reset Query
                                wp_reset_query();
                                wp_reset_postdata();
                                rewind_posts();
                            ?>
                        </li>

                        <li style="display:none;">
                            <label style="width:140px;display: inline-block;">File URL:</label>
                            <input type="text" id="file_url" name="file_url" style="width:67%" />                    
                        </li>
                        <div style="padding-left:143px; "><i>To change the size of the windows frame used to show the calculator or form, adjust the Iframe width and Iframe height.</i></div>
                        
                        <li>
                            <label style="width:140px;display: inline-block;">Iframe Width:<em style="color:red">*</em></label>
                            <input type="text" id="iframe_width" name="iframe_width" style="width:25%" />
                        </li>
                        <li>
                            <label style="width:140px;display: inline-block;">Iframe Height: <em style="color:red">*</em></label>
                            <input type="text" id="iframe_height" name="iframe_height" style="width:25%" />                    
                        </li>
                          <?php                      
                              $jquery_min = TF_CPT_PLUGIN_URL_MANAGER.'js/jquery.min.js';
                              $jquery_ui = TF_CPT_PLUGIN_URL_MANAGER.'js/jquery-ui.js';
                              $admin_js = TF_CPT_PLUGIN_URL_MANAGER.'js/admin.js';
                          ?>
                         
                         <input type="hidden" id="jquery_min" name="jquery_min" value="<?php echo $jquery_min;?>"/> 
                         <input type="hidden" id="jquery_ui" name="jquery_ui" value="<?php echo $jquery_ui;?>"/> 
                         <input type="hidden" id="admin_js" name="admin_js" value="<?php echo $admin_js;?>"/>   

                        <input type="text" style="display:none" id="admin_url" value="<?php echo admin_url('admin-ajax.php');?>" >
                </ul>

                    <input class="button-primary" type="button" id="insertbutton" style="margin-left:145px" value="<?php _e('Insert Calculator', 'spennare'); ?>">
                    <a class="button" onclick="tb_remove(); return false;" href="#">Cancel</a>

                
            </form>
            </div>

            </div>


          </div>
        </div>
        <script type="text/javascript"></script>

    <?php
    }
//Ajax Call For Url of Pages
    add_action( 'wp_ajax_Ajax_Link_Page', 'Ajax_Link_Page' );
    add_action( 'wp_ajax_nopriv_Ajax_Link_Page', 'Ajax_Link_Page' );

    function Ajax_Link_Page(){
      $postid = $_POST['post_id'];
        $fileurl = get_post_meta($postid,'wp_custom_attachment',true);
        $height = get_post_meta($postid,'wp_custom_attachment_height',true);
      $width = get_post_meta($postid,'wp_custom_attachment_width',true);
        echo json_encode(array('html' => $fileurl,'height'=>$height,'width'=>$width));
        exit;



    }

    //Adding the ShortCode For Button
    function shortcode_button_function($atts,$content = null) {
        extract(shortcode_atts(array("postid" =>''), $atts));
        $return_string = "";
         $post = get_post(intval($postid ));
         $post_thumbnail_id = get_post_thumbnail_id( $postid );
         $subtitle = get_post_meta($postid,'sub_title_kb',true);
         $content = get_post_meta($postid,'content_kb',true);
         $telefon = get_post_meta($postid,'telefon_kb',true);
         $email = get_post_meta($postid,'email_kb',true);
         $imagearr = wp_get_attachment_image_src( $post_thumbnail_id,'full');

        $return_string .='<table class="newfeatures"><tbody><tr class="row-1">';
        if($imagearr[0]):
           $return_string .= '<td class="column-1" style="float:none"><div class="imgPart"><img src="'. get_template_directory_uri().'/scripts/timthumb.php?src='.$imagearr[0].'&w=224" alt=""/></div></td>';
        endif;
                    if($post->post_title || $post->post_content ):
                    $return_string .= '<td class="column-2" style="float:none"><div class="textPart">
                     <!--edit starts here for title-->
                     <h2>'.$post->post_title.'</h2><p><span class="purple">'.$subtitle.'</span>
                     <!--edit ends here for title-->
                    '. $content.'</p><p class="purpleinfo"><span class="hidden-xs shortinfo"><strong>Telefon:</strong> '.$GLOBALS['otherinformation']["tt_telephone_otherinformation_1"][0].'</span><span class="visible-xs shortinfo"><strong>Telefon:</strong> <a href="'.$GLOBALS['otherinformation']["tt_telephone_otherinformation_1"][0].'">'.$GLOBALS['otherinformation']["tt_telephone_otherinformation_1"][0].'</a></span><span class="shortinfo"><strong>Mail:</strong> <a href="mailto: '.$GLOBALS['otherinformation']["tt_mail_otherinformation_1"][0].'">'.$GLOBALS['otherinformation']["tt_mail_otherinformation_1"][0].'</a></span></p>
                </div></td>';
                endif;
                $return_string .='</tr></tbody></table>';

                return $return_string;
    }

    function tulips_register_shortcodes(){
       // add_shortcode('quick_contact','shortcode_button_function');
    }
    add_action( 'init', 'tulips_register_shortcodes');


    /**
    create a post type to upload file attachment
    */

    function codex_custom_init() {
      $labels = array(
        'name'                => _x( 'Upload SSC Calculator', 'Post Type General Name', 'twentythirteen' ),
        'singular_name'       => _x( 'Calculator', 'Post Type Singular Name', 'twentythirteen' ),
        'menu_name'           => __( 'Upload SSC Calculator', 'twentythirteen' ),
        'parent_item_colon'   => __( 'Parent Calculator', 'twentythirteen' ),
        'all_items'           => __( 'All Calculators', 'twentythirteen' ),
        'view_item'           => __( 'View Calculator', 'twentythirteen' ),
        'add_new_item'        => __( 'Add New Calculator', 'twentythirteen' ),
        'add_new'             => __( 'Add New', 'twentythirteen' ),
        'edit_item'           => __( 'Edit Calculator', 'twentythirteen' ),
        'update_item'         => __( 'Update Calculator', 'twentythirteen' ),
        'search_items'        => __( 'Search Calculator', 'twentythirteen' ),
        'not_found'           => __( 'Not Found', 'twentythirteen' ),
        'not_found_in_trash'  => __( 'Not found in Trash', 'twentythirteen' ),
    );

      $supports = array('title');
        $args = array(
          'public' => true,
          'labels'  => $labels,
          'supports' => $supports,

        );
        register_post_type( 'file', $args );
    }
    add_action( 'init', 'codex_custom_init' );

    function add_custom_meta_boxes() {

        // Define the custom attachment for posts
        add_meta_box(
            'wp_custom_attachment',
            ' Upload the package of SSC calculator ',
            'wp_custom_attachment',
            'file',
            'normal'
        );



    } // end add_custom_meta_boxes
    add_action('add_meta_boxes', 'add_custom_meta_boxes');

    //updated 02/09/2017 Dipesh Karmacharya Issue with worpress visibility functions like edit permalink,publish...
    function fb_remove_postbox() {
        //wp_deregister_script('postbox');
    }
    add_action( 'admin_init', 'fb_remove_postbox' );
    
    function wp_custom_attachment() {
    global $post;
        wp_nonce_field(plugin_basename(__FILE__), 'wp_custom_attachment_nonce');
        $link = get_post_meta($post->ID,'wp_custom_attachment','true');
        if($link){
        $fileArray = explode( '/', $link );
        $reverse = array_reverse( $fileArray );
        $zipFileName = $reverse[1].'.zip';

         global $wpdb;
        $row = $wpdb->get_results( "SELECT * FROM ".$wpdb->prefix."posts WHERE ((post_content LIKE '%".$reverse[1]."%') and post_status = 'publish') or ((post_content LIKE '%".$reverse[1]."%') and post_status = 'draft')");
        }

        $html = '<div class="errorMessage"  class="messageBox messageError"></div><p class="description">';
        $html .= 'Please upload the package created by the SpreadsheetConverter. To create the package, go to Excel > SpreadsheetConverter Ribbon > Share menu > WordPress Share.';
        
        $html .= '</p>';

        $html .= '<div style="position:relative"><div class="uploadFileWrapper">        
        <input id="uploadFile" placeholder="No zip selected" disabled="disabled" style="display:none;"/>
        <div class="fileUpload btn btn-primary">
            <span class="button-primary">Choose Package</span>
            <input id="wp_custom_attachment1" name="wp_custom_attachment" type="file" class="upload" data-oldzip="'.$zipFileName.'" data-samezip="'.count($row).'"/>
        </div></div>';
        if($link){
                $html .= '<div id="fileNameZip" class="fileName">'.$zipFileName.'</div></div>
                            <div id="successMessage" class="messageBox messageSuccess update"></div>
                            <div id="errorMessage" class="messageBox messageError update"></div>';

        }else{
                $html .= '<div id="fileNameZip" class="fileName"></div></div>
                            <div id="successMessage" class="messageBox messageSuccess"></div>
                            <div id="errorMessage" class="messageBox messageError"></div>';
        }
               
        if($link){
                $html .= '<input readonly type="text" id="wp_custom_attachment_hidden" name="wp_custom_attachment_hidden" value="'.$link.'" size="90" class="hidden"/>';
            }

        echo $html;

    } // end wp_custom_attachment


    function save_custom_meta_data($id) {
        // wp_die("no publish");
        global $wpdb;
        /* --- security verification --- */
        if(!wp_verify_nonce($_POST['wp_custom_attachment_nonce'], plugin_basename(__FILE__))) {
          return $id;
        } // end if

        if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {            
          return $id;
        } // end if

        if('page' == $_POST['post_type']) {
          if(!current_user_can('edit_page', $id)) {
            return $id;
          } // end if
        } else {
            if(!current_user_can('edit_page', $id)) {
                return $id;
            } // end if
        } // end if
        /* - end security verification - */
              
        // Make sure the file array isn't empty
        if(!empty($_FILES['wp_custom_attachment']['name'])) {

            // Setup the array of supported file types. In this case, it's just PDF.
            $supported_types = array('application/zip');

            // Get the file type of the upload
            $arr_file_type = wp_check_filetype(basename($_FILES['wp_custom_attachment']['name']));
            $uploaded_type = $arr_file_type['type'];

            // Check if the type is supported. If not, throw an error.
            if(in_array($uploaded_type, $supported_types)) {

                $upload_dir = wp_upload_dir();
                $folder_name = basename($_FILES['wp_custom_attachment']['name'],".zip");
                $pub_dir = $upload_dir['basedir'] . '/ssc';
                $upload =  site_url().'/wp-content/uploads/ssc/'.$folder_name.'/'.$folder_name.'.htm';
                if (!is_dir($upload_dir)) {
                   mkdir( $pub_dir, 0775 );
                }
                $source = $_FILES['wp_custom_attachment']['tmp_name'];
                $target_path = $pub_dir."/".$_FILES['wp_custom_attachment']['name'];  // change this to the correct site path
              
               $path = $upload_dir['basedir'].'/ssc/'.$folder_name.'/'.$folder_name.'.htm';
              
                if(move_uploaded_file($source, $target_path)) {
                    // if(class_exists('ZipArchive')){
                    
                        $zip = new ZipArchive();
                        $x = $zip->open($target_path);              

                       
                        if ($x === true) {
                           $zipall    =   zip_open($target_path);            

                             while (($zip_entry = zip_read($zipall)))
                                  {
                                       $pathall = zip_entry_name($zip_entry);
                                  }
                                  $pathall = explode("/", $pathall);
                                 
                                  if($pathall[0] == $folder_name){
                                    $pub_dir = $pub_dir;
                                  }elseif($pathall[0] != $folder_name){
                                    $pub_dir = $pub_dir."/".$folder_name;
                                  }
                          $zip->extractTo( $pub_dir.'/'); // change this to the correct site path

                          $zip->close();

                        unlink($target_path);
                        }   
                    
                    // }else{

                    //      $_SESSION['check_version'] .= '<div class="updated" style="color:red"><p>Please install or enable PHP extension ZIPArchive.</p></div>'; 
                    //      return false;
                     
                    // }
                        
               
                 if(file_exists($path)){
                     $upload =   site_url().'/wp-content/uploads/ssc/'.$folder_name.'/'.str_replace(" ","%20",$folder_name).'.htm';
                     $upload_link =   site_url().'/wp-content/uploads/ssc/'.str_replace(" ","%20",$folder_name).'/'.str_replace(" ","%20",$folder_name).'.htm';
            
                }
                else{
                    $upload =  site_url().'/wp-content/uploads/ssc/'.$folder_name.'/index.htm';
                    $upload_link =  site_url().'/wp-content/uploads/ssc/'.str_replace(" ","%20",$folder_name).'/index.htm';
                    


                }

                $input = site_url().'/wp-content/uploads/ssc/'.str_replace(" ","%20",$folder_name).'/insert_into_website.htm';
               


                // match plugin and spreadsheet converter version
                $address = $upload_link;  
                $dir = $upload_dir['basedir'].'/ssc/'.$folder_name.'/';           

                $inputData = file_get_contents($address);
                 // or die("Could not access file: $address");
                if($inputData){
                
              
                    $regexp = "<input type='hidden' id='xl_client' name='xl_client' value='([^']+)' />"; 

                    if(preg_match_all($regexp, $inputData, $matches, PREG_SET_ORDER)) { 
                        // echo "<pre>";print_r($matches);exit;

                        $zip_file_version = $matches[0][1];
                        $zip_file_version = str_replace('x', '', $zip_file_version);
                        // $zip_file_version = substr($zip_file_version, 0, 1);
                        $zip_file_version = explode('.',$zip_file_version);
                      
                        
                        $plugin_version = tulips_shortcode_manager_version();
                        // $plugin_version = substr($plugin_version, 0, 1);
                        $plugin_version = explode('.',$plugin_version);
                        if($plugin_version[0] < $zip_file_version[0]){    
                        
                            errorLog('You need version '.$zip_file_version[0].' of Wordpress Plugin for upload process');
                            $_SESSION['check_version'] .= '<div class="updated" style="color:red"><p>You need version '.$zip_file_version[0].' of Wordpress Plugin for upload process</p></div>';                       
                           
                            $prevent_publish= true;//Set to true if data was invalid.

                            if ($prevent_publish) {
                                // unhook this function to prevent indefinite loop
                                remove_action('save_post', 'save_custom_meta_data');
                               
                                // // update the post to change post status
                                wp_update_post(array('ID' => $id, 'post_status' => 'draft'));
                                // // re-hook this function again
                                add_action('save_post', 'save_custom_meta_data');
                            }
                        rrmdir($dir);
                        return false;
                            
                        }elseif($plugin_version[0] > $zip_file_version[0]){

                            errorLog('You need version '.$plugin_version[0].' of SpreadsheetConverter to use this plugin');
                            $_SESSION['check_version'] .= '<div class="updated" style="color:red"><p>You need version '.$plugin_version[0].' of SpreadsheetConverter to use this plugin</p></div>';                       
                            
                            $prevent_publish= true;//Set to true if data was invalid.

                            if ($prevent_publish) {
                                // unhook this function to prevent indefinite loop
                                remove_action('save_post', 'save_custom_meta_data');
                               
                                // // update the post to change post status
                                wp_update_post(array('ID' => $id, 'post_status' => 'draft'));
                                // // re-hook this function again
                                add_action('save_post', 'save_custom_meta_data');
                            }
                        
                        rrmdir($dir);
                        return false;

                        }
                    } 
                }      
                       
                if($_POST['save'] || $_POST['publish']){
                        if($_POST['post_title'] == ''){
                           
                            update_post_meta($id, '_title', $folder_name);
                             $wpdb->query( $wpdb->prepare("UPDATE $wpdb->posts SET post_title = %s WHERE ID = %d ",$folder_name,$id) );
                        }                        
                    }
                $height = get_iframe_height( file_get_contents( $input) );
                $width = get_iframe_width( file_get_contents( $input) );

                $postID = get_post_meta($id, 'wp_custom_attachment',true);

                if($postID):
                    update_post_meta($id, 'wp_custom_attachment', $upload);
                    update_post_meta($id, 'wp_custom_attachment_height', $height[0]);
                    update_post_meta($id, 'wp_custom_attachment_width', $width[0]);
                  else:
                    add_post_meta($id, 'wp_custom_attachment', $upload);
                    add_post_meta($id, 'wp_custom_attachment_height', $height[0]);
                    add_post_meta($id, 'wp_custom_attachment_width', $width[0]);
                    endif;
                //$message = "Your .zip file was uploaded and unpacked.";
              } else {
                errorLog('There was a problem with the upload.');
                wp_die("There was a problem with the upload. Please try again.");
              }

            } else {
                errorLog('The file type that you have uploaded is not a ZIP.');
                wp_die("The file type that you've uploaded is not a ZIP.");
            } // end if/else

        } // end if
         

    } // end save_custom_meta_data    

    add_action('save_post', 'save_custom_meta_data');
    /**
     * Recursively removes a folder along with all its files and directories
     * 
     * @param String $path 
     */
    function rrmdir($path) {
         // Open the source directory to read in files
            $i = new DirectoryIterator($path);
            foreach($i as $f) {
                if($f->isFile()) {
                    unlink($f->getRealPath());
                } else if(!$f->isDot() && $f->isDir()) {
                    rrmdir($f->getRealPath());
                }
            }
            rmdir($path);
    }
  
    function check_version(){
      if(!empty($_SESSION['check_version']))
        print  $_SESSION['check_version'];        
        unset ($_SESSION['check_version']);
    }
    add_action( 'admin_notices', 'check_version' );

    add_filter( 'post_updated_messages', 'post_published' );
    function post_published( $messages )
    {
        if(!empty($_SESSION['check_version']))
        unset($messages[post][6]);
        return $messages;
    }

    function ssc_update_edit_form() {
        echo ' enctype="multipart/form-data"';
    } // end update_edit_form
    add_action('post_edit_form_tag', 'ssc_update_edit_form');

    /**
    end of  file attachment
    */

    /* change title text*/

    function wpb1_change_title_text( $title ){
     $screen = get_current_screen();
     //echo '<pre>';print_r($screen);
     if  ( 'file' == $screen->post_type ) {
          $title = 'Enter calculator name';
     }

     return $title;
    }

    add_filter( 'enter_title_here', 'wpb1_change_title_text' );

    /**
    Make title field mandatory for post type file
    **/


    // function ssc_post_title() {
    //     $screen = get_current_screen();
    //      if  ( 'file' == $screen->post_type ) {

    // echo "<script type='text/javascript'>\n";
    // echo "

    //   jQuery('#publish').click(function(){
    //     var testervar = jQuery('[id^=\"titlediv\"]')
    //     .find('#title');
    //     if (testervar.val().length < 1)
    //     {
    //       jQuery('#title').css('border', '2px solid red');
    //       setTimeout(\"jQuery('#ajax-loading').css('visibility', 'hidden');\", 100);
    //       alert('Calculator name is required');
    //       setTimeout(\"jQuery('#publish').removeClass('button-primary-disabled');\", 100);
    //       return false;
    //     }
    //   });

    // ";
    //     echo "</script>\n";
    // }
    // }
    // /*add_action('admin_init', 'force_post_title_init');*/
    // add_action('edit_form_advanced', 'ssc_post_title');


    /**
 * Returns current plugin version.
 * 
 * @return string Plugin version
 */

    function tulips_shortcode_manager_version() {
        if ( ! function_exists( 'get_plugins' ) )
            require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
        $plugin_folder = get_plugins( '/' . plugin_basename( dirname( __FILE__ ) ) );
        $plugin_file = basename( ( __FILE__ ) );
        return $plugin_folder[$plugin_file]['Version'];
    }



     add_action('edit_form_advanced', 'get_version');
    function get_version(){  
        $screen = get_current_screen();
            if  ( 'file' == $screen->post_type ) {
                echo "<script type='text/javascript'>\n";
                echo "

                  jQuery('#publish').click(function(){

                    if (!jQuery('#wp_custom_attachment').find('#uploadFile').val() && !jQuery('#wp_custom_attachment').find('#wp_custom_attachment_hidden').val())
                    {    
                      
                       jQuery('[id^=\"wp_custom_attachment\"]').css('background', '#F96');
                      setTimeout(\"jQuery('#ajax-loading').css('visibility', 'hidden');\", 100);
                      alert('You need SpreadsheetConverter version 9 Professional Edition to benefit from the simple convenience of the spreadsheet upload plugin.');
                      setTimeout(\"jQuery('#publish').removeClass('button-primary-disabled');\", 100);
                      return false;
                    }
                  });

                ";

                echo "</script>\n";
       
        }
    }


/* get iframe width and height from sample page*/
    function get_iframe_height( $input ) {

        preg_match_all("/<iframe[^>]*height=[\"|']([^'\"]+)[\"|'][^>]*>/i", $input, $output );

        $return = array();

        if( isset( $output[1][0] ) ) {

            $return = $output[1];

        }
        return $return;

    }

    function get_iframe_width( $input ) {

        preg_match_all("/<iframe[^>]*width=[\"|']([^'\"]+)[\"|'][^>]*>/i", $input, $output );

        $return = array();

        if( isset( $output[1][0] ) ) {

            $return = $output[1];

        }

        return $return;

    }


    // writing to the log file

// $file = plugin_dir_path( __FILE__ ) . '/errors.txt'; 
// $open = fopen( $file, "a" ); 

// add_action( 'get_header', 'mail_me_errors' );

// function mail_me_errors() {
//     if ( is_404() ) {
//         email_admin( $_SERVER['REQUEST_URI'] );
//     }
// }

// function email_admin( $location ) {   
//     $time = date( "F jS Y, H:i", time()+25200 );
//     $ban = "#$time\r\n$location\r\n"; 
//     $file = plugin_dir_path( __FILE__ ) . '/errors.txt'; 
//     $open = fopen( $file, "a" ); 
//     $write = fputs( $open, $ban ); 
//     fclose( $open );
// }
// get_usermeta(3);


// if (defined('WP_DEBUG_LOG') && WP_DEBUG_LOG) {
//     // echo 'test plugin';die();
//     ini_set( 'error_log', TF_CPT_PLUGIN_URL_MANAGER . '/debug.log' );
// }
           
//     if ( ! function_exists('write_log')) {
//    function write_log ( $log )  {
//       if ( is_array( $log ) || is_object( $log ) ) {
//          error_log( print_r( $log, true ) );          
                 

//       } else {
//          error_log( $log );
//       }
//    }
// }

// Logging class initialization
// $log = new Logging();
 
// // set path and name of log file (optional)
// $log->lfile(TF_CPT_PLUGIN_URL_MANAGER.'debug.txt');
 
// // write message to the log file
// $log->lwrite('Test message1');
// $log->lwrite('Test message2');
// $log->lwrite('Test message3');
 
// // close log file
// $log->lclose();

// /** 
//  * Logging class:
//  * - contains lfile, lwrite and lclose public methods
//  * - lfile sets path and name of log file
//  * - lwrite writes message to the log file (and implicitly opens log file)
//  * - lclose closes log file
//  * - first call of lwrite method will open log file implicitly
//  * - message is written with the following format: [d/M/Y:H:i:s] (script name) message
//  */

// class Logging {
//     // declare log file and file pointer as private properties
//     private $log_file, $fp;
//     // set log file (path and name)
//     public function lfile($path) {
//         $this->log_file = $path;
//     }
//     // write message to the log file
//     public function lwrite($message) {
//         // if file pointer doesn't exist, then open log file
//         if (!is_resource($this->fp)) {
//             $this->lopen();
//         }
//         // define script name
//         $script_name = pathinfo($_SERVER['PHP_SELF'], PATHINFO_FILENAME);
//         // define current time and suppress E_WARNING if using the system TZ settings
//         // (don't forget to set the INI setting date.timezone)
//         $time = @date('[d/M/Y:H:i:s]');
//         // write current time, script name and message to the log file
//         fwrite($this->fp, "$time ($script_name) $message" . PHP_EOL);
//     }
//     // close log file (it's always a good idea to close a file when you're done with it)
//     public function lclose() {
//         fclose($this->fp);
//     }
//     // open log file (private method)
//     private function lopen() {
//         // in case of Windows set default log file
//         // if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
//         //     $log_file_default = TF_CPT_PLUGIN_URL_MANAGER.'debug.txt';
//         // }
//         // // set default log file for Linux and other systems
//         // else {
//         //     $log_file_default = TF_CPT_PLUGIN_URL_MANAGER.'debug.txt';
//         // }
//           $log_file_default = TF_CPT_PLUGIN_URL_MANAGER.'debug.txt';
//         // define log file from lfile method or use previously set default
//         $lfile = $this->log_file ? $this->log_file : $log_file_default;
//         // open log file for writing only and place file pointer at the end of the file
//         // (if the file does not exist, try to create it)
//         $this->fp = fopen($lfile, 'a') or exit("Can't open $lfile!");
//     }
// }


// $myfile = fopen(TF_CPT_PLUGIN_URL_MANAGER.'debug.txt', 'w') or die("Unable to open file!");
// $txt = "user id date";
// fwrite($myfile, "\n". $txt);
// fclose($myfile);
// echo $myFile = TF_CPT_PLUGIN_URL_MANAGER.'debug.txt';
// if (!file_exists($myFile)) {
//   print 'File not found';die;
// }
// else if(!$fh = fopen($myFile, 'w')) {
//   print 'Can\'t open file';
// }
// else {
//   print 'Success open file';
// }

    // $location = fopen(TF_CPT_PLUGIN_URL_MANAGER."debug.txt", "a") or die("Unable to open file!");
    // $txt = "user id date";
    // fwrite($location, "\n". $txt);
    // fclose($location);

    // echo $location;
    // fclose($location);
    function errorLog($message){

       


        $dir = dirname(__FILE__) . '/debug.txt';
       
        $time = date( "F j, Y");
        $message = '['.$time.'] '.$message . "\n";
        // $your_data = "This is the data to be stored in the text file.";
        // Open the file and erase the contents if any
        $fp = fopen($dir, "a");
        // Write the data to the file
        fwrite($fp, $message);
        // Close the file
        fclose($fp); 
    }


